#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xlib.h>
#include <dve/Xm/recipientList.h>

#include <Xm/Xm.h>

#ifdef MOTIF
#include <Xm/Xm.h>
#include <Xm/MwmUtil.h>
#include <Xm/MenuShell.h>
#endif /* MOTIF */

#include <Xm/PushB.h>
#include <Xm/Form.h>
#include <Xm/ToggleB.h>
#include <Xm/Label.h>
#include <X11/Shell.h>

XtAppContext	AppContext;
Widget		TopLevel;
Display		*display;
int		screen;
Widget MyShell;
Widget MainForm;
Widget bPlay, bPause, bBskip, bFskip, bStop, bToggle, bExit;
Widget messagelabel;
XmString label;
char *hostname;


extern finish();
extern start_playing();
extern void play();
extern void pause();
extern void bwd(void);
extern void fwd(void);
extern void stop();
extern void toggled();
void SetMessage(const char *msg);
 
Widget build_interface(Widget parent);

/*----------------------------------------------
 * Insert application global declarations here
 *---------------------------------------------*/


#ifdef _NO_PROTO
main(argc,argv)
        int     argc;
        char    *argv[];
#else
main( int argc, char *argv[])
#endif /* _NO_PROTO */
{
	/*-----------------------------------------------------------
	 * Declarations.
         * The default identifier - mainIface will only be declared 
	 * if the interface function is global and of type swidget.
	 * To change the identifier to a different name, modify the
	 * string mainIface in the file "xtmain.dat". If "mainIface"
         * is declared, it will be used below where the return value
	 * of  PJ_INTERFACE_FUNCTION_CALL will be assigned to it.

         *----------------------------------------------------------*/ 

  	Widget mainIface;

	/*---------------------------------
	 * Interface function declaration
	 *--------------------------------*/	

	/*---------------------
	 * Initialize program
	 *--------------------*/

  	TopLevel = XtAppInitialize(&AppContext, "VideoPluginMotif",
				     NULL, 0, &argc, argv, NULL, NULL, 0);
	display = XtDisplay(TopLevel);
	screen = XDefaultScreen(display);

	/* We set the geometry of UxTopLevel so that dialogShells
	   that are parented on it will get centered on the screen
	   (if defaultPosition is true). */

	XtVaSetValues(TopLevel,
			XtNx, 0,
			XtNy, 0,
			XtNwidth, DisplayWidth(display, screen),
			XtNheight, DisplayHeight(display, screen),
			NULL);

	/*-------------------------------------------------------
	 * Insert initialization code for your application here 
	 *------------------------------------------------------*/
	

	/*----------------------------------------------------------------
	 * Create and popup the first window of the interface.  The 	 
	 * return value can be used in the popdown or destroy functions.
         * The Widget return value of  PJ_INTERFACE_FUNCTION_CALL will 
         * be assigned to "mainIface" from  PJ_INTERFACE_RETVAL_TYPE. 
	 *---------------------------------------------------------------*/

	introduceYourself();

	mainIface = build_interface(TopLevel);

	XtPopup(MyShell, XtGrabNone);

	/*-----------------------
	 * Enter the event loop 
	 *----------------------*/

  	XtAppMainLoop (AppContext);

}


Widget build_interface(Widget parent)
{

    MyShell = XtVaCreatePopupShell( "recipTestAppShell",
				 applicationShellWidgetClass,
				 parent,
				 XmNx, 370,
				 XmNy, 300,
				 XmNwidth, 400,
				 XmNheight, 300,
				 XmNtitle, "VideoPlugin",
				 XmNiconName, "VideoPlugin",
				 XmNmwmDecorations, 2|16|32,
				 XmNmwmFunctions, 4|8|32,
				 NULL );

	MainForm = XtVaCreateManagedWidget( "recipTestMainForm",
			xmFormWidgetClass,
			MyShell,
			XmNresizePolicy, XmRESIZE_NONE,
			XmNunitType, XmPIXELS,
			XmNwidth, 400,
			XmNheight, 300,
			NULL );


	label = XmStringCreateSimple("PLAY");
	bPlay = XtVaCreateManagedWidget("play", xmPushButtonWidgetClass,
					 MainForm,
					 XmNlabelString, label, 
					 XmNx, 10, 
					 XmNy, 50,
					 XmNwidth, 55,
					 XmNheight, 30,
					 NULL);

	XmStringFree(label);
	XtAddCallback(bPlay, XmNactivateCallback, play, NULL);
	XtSetSensitive(bPlay, True);

	label = XmStringCreateSimple("|<<");
	bBskip = XtVaCreateManagedWidget("bskip", xmPushButtonWidgetClass,
					 MainForm,
					 XmNlabelString, label, 
					 XmNx, 70, 
					 XmNy, 50,
					 XmNwidth, 55,
					 XmNheight, 30,
					 NULL);

	XmStringFree(label);
	XtAddCallback(bBskip, XmNactivateCallback, bwd, NULL);
	XtSetSensitive(bBskip, False);

	label = XmStringCreateSimple(">>|");
	bFskip = XtVaCreateManagedWidget("fskip", xmPushButtonWidgetClass,
					 MainForm,
					 XmNlabelString, label, 
					 XmNx, 130, 
					 XmNy, 50,
					 XmNwidth, 55,
					 XmNheight, 30,
					 NULL);

	XmStringFree(label);
	XtAddCallback(bFskip, XmNactivateCallback, fwd, NULL);
	XtSetSensitive(bFskip, False);

	label = XmStringCreateSimple("PAUSE");
	bPause = XtVaCreateManagedWidget("pause", xmPushButtonWidgetClass,
					 MainForm,
					 XmNlabelString, label, 
					 XmNx, 190, 
					 XmNy, 50,
					 XmNwidth, 55,
					 XmNheight, 30,
					 NULL);

	XmStringFree(label);
	XtAddCallback(bPause, XmNactivateCallback, pause, NULL);
	XtSetSensitive(bPause, False);

	label = XmStringCreateSimple("Stop");
	bStop = XtVaCreateManagedWidget("stop", xmPushButtonWidgetClass,
					 MainForm,
					 XmNlabelString, label, 
					 XmNx, 250, 
					 XmNy, 50,
					 XmNwidth, 55,
					 XmNheight, 30,
					 NULL);

	XmStringFree(label);
	XtAddCallback(bStop, XmNactivateCallback, stop, NULL);
	XtSetSensitive(bStop, False);

/*	label = XmStringCreateSimple("To file");
	bToggle = XtVaCreateManagedWidget("dump",
					 xmToggleButtonWidgetClass,
					 MainForm,
					 XmNlabelString, label, 
					 XmNx, 270, 
					 XmNy, 50,
					 XmNwidth, 120,
					 XmNheight, 35,
					 NULL);

	XmStringFree(label);
	XtAddCallback(bToggle, XmNvalueChangedCallback, toggled, NULL);
*/
	label = XmStringCreateSimple("Exit");
	bExit = XtVaCreateManagedWidget("Exit", xmPushButtonWidgetClass,
					 MainForm,
					 XmNlabelString, label, 
					 XmNx, 310, 
					 XmNy, 50,
					 XmNwidth, 55,
					 XmNheight, 30,
					 NULL);

	XmStringFree(label);
	XtAddCallback(bExit, XmNactivateCallback, finish, NULL);
	XtSetSensitive(bExit, True);

	messagelabel = XtVaCreateManagedWidget( "messagelabel",
			xmLabelWidgetClass,
			MainForm,
			XmNx, 20,
			XmNy, 10,
			XmNwidth, 300,
			XmNheight, 10,
			NULL );
	SetMessage("Press PLAY to start...");

  return MyShell;
}

void SetMessage(const char *msg)
{
  XmString str=XmStringCreateSimple((char*)msg);
  XtVaSetValues(messagelabel,
		XmNlabelString, str,
		NULL);
  XmStringFree(str);
}
