/*
 *
 * Name:        Plugin_procs.c
 *
 * Description: user and OpenDVE events callbacks               
 *
 * Author:	Janusz Bulawa, NPAC
 *
 * Date:	july 1996
 */

#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <sys/param.h>
#include "VideoProtocol.h"

#include <X11/Intrinsic.h>

/* H263 display section */
#define GLOBAL
#include "config.h"
#include "tmndec.h"
#include "global.h"

/* private prototypes */
static void initdecoder _ANSI_ARGS_((void));
static int getval _ANSI_ARGS_((char *argv[]));

  int first;
/* end of H263 display section */

extern AppContext;
extern MyShell;
extern MainForm;
extern hostname;
extern bPlay;
extern bPause;
extern bStop;
extern bExit;
extern bToggle;
extern bFskip;
extern bBskip;

Widget MainWindow;

DveSession dvePluginSession=NULL;
DveSession dveVideoCtlSession=NULL;
DveSession dveVideoDataSession=NULL;
char *moviename;
int search=0;
extern state;

void start_conference(void);
void finish(void);
void started(DveSession dvePluginSession, DveEvent* event);
void HidePlugin();
void ShowPlugin();
void play(void);
void pause(void);
void bwd(void);
void fwd(void);
void stop(void);
void toggled(void);

void SendVideoData(void);
void SendMessage(VideoTag messageType, DvePort port, VideoPluginArg *dane);
int SendPluginMessageGeneric(DveSession dveSession, u_int32 protocol, DvePort port,
			u_int32 messageType, int dest, void *data, u_int32 size);
extern SetMessage(const char *msg);

XtIntervalId timerId=0;
/* XtRemoveTimeOut(timerId);*/
/* timerId = XtAppAddTimeOut(AppContext,interval,SendVideoData,NULL); */

  char *data;


void SendVideoData(void)
{
  char *buffer;
  int len,i;

  if (!vdata) printf("Error allocating buffer for video data!\n");
  len = IOreadNextVideoFrame(moviefd, framenumS, vdata, &search);
  framenumS++; /* move to the next */

  printf("Sending video data %d bytes\n", len);
/*  for (i=0;i<len;i++) printf("%d ", vdata[i]);
  printf("\n");
  */
  if (len>0)
  {
    SendPluginMessageGeneric(dveVideoDataSession,H263_DATA_PORT,H263_DATA_PORT,
	  		     videoTagData,-1,vdata,len);
    if (state==PLAY)
      timerId = XtAppAddTimeOut(AppContext,100,SendVideoData,NULL);
  }

  return;
}

void SendSpecificMessage(VideoTag messageType)
{
   static VideoPluginArg dane;
   char *title;

   switch (messageType) {
   case videoTagPlay:
     title="/home/R11A/bulawa/rzepa/i10heads.263";
     memcpy((char*)dane.movie_title, title, strlen(title));
     break;
   case videoTagPause:
     break;
   case videoTagResume:
     break;
   case videoTagFwSkip:
     break;
   case videoTagBwSkip:
     break;
   case videoTagStop:
     break;
   case videoTagNewMovie:
     break;
   case videoTagExit:
     break;
   case videoTagConfirm:
     break;
   case videoTagDenied:
     break;
   default:
     printf("Unknown request!\n");
     break;
   }

   SendMessage(messageType, VIDEO_PLUGIN_PORT, &dane); 
}

static void
ProcessVideoData(DveSession dveSession, DveUserHandle sender,
                 DveDataPacket* packet)
{
  int i, size, f;

  size = (packet->size)-sizeof(DveDataPacket)+1;
/*  data = (char *)dveMalloc(size);
  if (!data)
  {
    printf("No memory space left!\n");
    return;
  }
  */
/*  printf("Dostalem dane VIDEO!!! length=%d\n", size);*/
  memcpy(videobuffer, packet->data, size);
/*  f=open("file.263", O_RDWR|O_CREAT);
  write(f, videobuffer, size);
  close(f);*/
  avail=size;
  videooffset=0;
/*  for (i=0;i<20;i++) printf("%d ", videobuffer[i]);
  printf("\n");
  for (i=0;i<20;i++) printf("%d ", videobuffer[size-i]);
  printf("\n");
*/
    initbits();
  if (getheader())
  {
    printf("DEKODUJE obrazek...\n");
    
    if (first) {
      initdecoder();
      first = 0;
    }
    getpicture(&framenumR);
    framenumR++;
  }
}

void play(void)
{
  DvePort port;
  char *title;
  
  port=H263_DATA_PORT;
  printf("Pressed start\n");
  state=PLAY;
  if (videobuffer)
  {
    XtSetSensitive(bPlay, False);	 
    XtSetSensitive(bPause, True);	 
    XtSetSensitive(bStop, True);  
    XtSetSensitive(bBskip, True);	 
    XtSetSensitive(bFskip, True);  
    SendSpecificMessage(videoTagPlay);
           title="/home/R11A/bulawa/rzepa/i20heavy.263";
           printf("requested play of the movie %s\n", title);
	   moviefd=IOopenVideoFile(title);
	   SendSpecificMessage(videoTagConfirm);
	   printf("Confirmation sent!\n");
	   printf("Video file ID=%d\n", moviefd);
	   framenumS=0;
	   state=PLAY;
	   SendVideoData();	   
  }
  else printf("Memory for video data not available!!! Can not start...\n");
  return;
}

void pause(void)
{
  printf("Pressed pause\n");
  XtSetSensitive(bPlay, True);	   
  SendSpecificMessage(videoTagPause);
}

void bwd(void)
{
  printf("Pressed Backward Skip\n");
  SendSpecificMessage(videoTagBwSkip);
}

void fwd(void)
{
  printf("Pressed forward Skip\n");
  SendSpecificMessage(videoTagFwSkip);
}

void stop(void)
{
  printf("Pressed stop\n");
  XtSetSensitive(bPlay, False);
  XtSetSensitive(bPause, True);
  SendSpecificMessage(videoTagStop);
}

void toggled(void)
{
  printf("Pressed toggled\n");
}

/* 
 * Callback invoked when an user pushes Exit button.
 */

void finish(void)
{

  SendSpecificMessage(videoTagExit);
/*  dveConfMgrLeaveConference(dvePluginSession);*/
  QuitPlugin(dvePluginSession);
}

void start_playing(void)
{
    printf("Start playing called\n");
    return;
}

void started(DveSession dveSession, DveEvent* event)
{
/*  int ilosc, i;
  ConfdStateTag stan;

  ilosc=event->arg.starting.numMembers;
  stan=event->arg.starting.state;
  fprintf(stdout, "I am invited! %d %d\n", ilosc, (int)stan);
  for (i=0;i<ilosc;i++)
    fprintf(stdout, "%s@%s\n", event->arg.starting.members[i].part.userName, event->arg.starting.members[i].part.hostName);
  fflush(stdout);
  */
}


QuitPlugin(DveSession dveSession)
{
 
#ifdef XT
   dveUnregisterWithXt(dveSession);
#endif
 
#ifdef XVIEW
   dveUnregisterWithXView(dveSession);
#endif

   dveCloseSession(dveSession);
 
   exit(0);
}

static void
VideoControlMsg(DveSession dveSession, DveUserHandle sender,
                 DveDataPacket* packet)
{
  static VideoPluginArg dane;
  memcpy(&dane, packet->data, sizeof(VideoPluginArg));

  printf("User#%d : ", sender);
  switch ((VideoTag)packet->tag)
   { 
      case videoTagExit:
         if (timerId!=0) XtRemoveTimeOut(timerId);
	 timerId=0;
         printf("requested exit\n");
	 XtSetSensitive(bPlay, True);
	 XtSetSensitive(bPause, False);
	 XtSetSensitive(bStop, False);
	 if (moviefd) IOcloseVideoFile(moviefd);
	 state=STOP;
         break;
      case videoTagPlay:
/*	 XtSetSensitive(bPlay, False);
	 XtSetSensitive(bPause, True);
	 XtSetSensitive(bStop, True);*/
	 if (state==STOP)
	 {
	   moviename=dane.movie_title;
           printf("requested play of the movie %s\n", moviename);
	   moviefd=IOopenVideoFile(moviename);
	   SendSpecificMessage(videoTagConfirm);
	   printf("Confirmation sent!\n");
	   printf("Video file ID=%d\n", moviefd);
	   framenumS=0;
         }
	 state=PLAY;
	 SendVideoData();
         break;
      case videoTagResume:
	 XtSetSensitive(bPlay, False);
	 XtSetSensitive(bPause, False);
	 XtSetSensitive(bStop, False);
	 state=PLAY;
	 SendVideoData();
         break;
      case videoTagPause:
         if (timerId!=0) XtRemoveTimeOut(timerId);
	 timerId=0;
         printf("requested Pause\n");
	 state=PAUSE;
         break;
      case videoTagStop:
         if (timerId!=0) XtRemoveTimeOut(timerId);
	 timerId=0;
         printf("requested Stop\n");
         break;
      case videoTagFwSkip:
         printf("requested Forward Skip\n");
	 framenumS=(int)((framenumS/20+1)*20);
	 search=1;
	 SendVideoData();
	 break;
      case videoTagBwSkip:
         printf("requested Backward Skip\n");
	 if (framenumS>=20)
	   framenumS=(int)((framenumS/20-1)*20);
	 search=1;
	 SendVideoData();
	 break;
      case videoTagConfirm:
         printf("Request Confirmed\n");
         break;
       default:
	 printf("Unknown request !\n");
   }
    
}

void
HidePlugin()
{
   XtPopdown(MyShell);
}
 
void
ShowPlugin()
{
   XtPopup(MyShell, XtGrabNone);
}
 
void
introduceYourself()
{
   /*
    * Start up OpenDVE.
    */
   if (!(dvePluginSession=dveOpenSession(VIDEO_PLUGIN_PORT)))
   {
      fprintf(stderr, "Initialization of OpenDVE Failed...exiting.\n\7");
      switch (dveError)
	{
	case dveErrOutOfMemory:
	  fprintf(stderr, "Error Condition: [Low memory.]\n");
	  break;
	  
	case dveErrNotFound:
	  fprintf(stderr, 
		  "Error Condition: [Conference Engine not found.]\n");
	  break;
	  
	case dveErrConnRefused:
	  fprintf(stderr, 
		  "Error Condition: [Engine refused connection.]\n");
	  break;
	default:
	  fprintf(stderr, "Unknown Error Condition.\n");
	  break;
	}
       exit(0);
   }

   dveVideoDataSession=dveOpenSession(H263_DATA_PORT);
   if (!dveVideoDataSession)
   {
      dveVideoDataSession=dvePluginSession;
      fprintf(stderr, "Initialization of OpenDVE for VIDEO failed....\n\7");
      switch (dveError)
	{
	case dveErrOutOfMemory:
	  fprintf(stderr, "Error Condition: [Low memory.]\n");
	  break;
	  
	case dveErrNotFound:
	  fprintf(stderr, 
		  "Error Condition: [Conference Engine not found.]\n");
	  break;
	  
	case dveErrConnRefused:
	  fprintf(stderr, 
		  "Error Condition: [Engine refused connection.]\n");
	  break;
	default:
	  fprintf(stderr, "Unknown Error Condition.\n");
	  break;
	}
   }
  dveSetUserCallback(dveVideoDataSession, H263_DATA_PORT, ProcessVideoData);

   dveSetUserCallback(dvePluginSession, VIDEO_PLUGIN_PORT, VideoControlMsg);

   dveSetEventCallback(dvePluginSession, dveEventTagStarting,started);   
    /*
    * Register this event processing with the Xt toolkit.  Without this
    * call OpenDVE events will not be received.
    */
   
   if (dveRegisterWithXt(dvePluginSession,AppContext)<0)
   {
      fprintf(stderr, "Unable to register with Xt loop.");
      dveCloseSession(dvePluginSession);
      exit(0);
   }
   if (dveRegisterWithXt(dveVideoDataSession,AppContext)<0)
   {
      fprintf(stderr, "Unable to register with Xt loop.");
      dveCloseSession(dveVideoDataSession);
      exit(0);
   }

   dveReportPresence(dvePluginSession);
   dveReportPresence(dveVideoDataSession);

  first=1;
  outtype=T_X11;
  ld = &base; 

  framenumS = 0;
  framenumR = 0;
  temp_ref = 0;
  prev_temp_ref -1; 
  outputname = "";
  videobuffer=(char*)dveMalloc(MAX_FRAME_SIZE);
  vdata = dveMalloc(MAX_FRAME_SIZE);
  avail=0;
  moviefd=0;
   
   printf("\n\nVideo Plugin starting...\n");
}

/*
 * Notify other conference members of our current settings.  We have
 * either made a change or have received a request to provide status.
 */
void
SendMessage(VideoTag messageType, DvePort port, VideoPluginArg *dane)
{
  DveSession session;

  if (messageType==videoTagData) session=dveVideoDataSession;
  else session=dvePluginSession;
  
   SendPluginMessageGeneric(session, port, port, messageType, -1, dane, sizeof(*dane));

   return;
}

/*
 * Passses data from this plugin to other conferenced members.
 */
int
SendPluginMessageGeneric(DveSession dveSession, u_int32 protocol, DvePort port,
			u_int32 messageType, int dest, void *data, u_int32 size)
{
   DveDataPacket *packet;
   DveConfParticipant member;
   int returnCode,i;

/*   printf("Size of data to send: %d\n", size);*/
   
   packet = (DveDataPacket*) dveMallocDataPacket(dveSession, size);
   packet->tag = (u_int32)messageType;
   packet->pluginProtocol = protocol;
   packet->destPort = port;

/*   printf("SendGeneric to port %d\n", packet->destPort);*/
   DvePartListClrAll(&(packet->destParts));

   if (dest < 0)
   {
      DvePartListSetAll(&(packet->destParts));
   }
   else
   {
      DvePartListSet(dest,&(packet->destParts));
   }

   if (size > 0)
      memcpy(packet->data, data, size);

/*   if (messageType==videoTagData)
    {
      printf("\nDane w pakiecie:\n");
      for(i=0;i<size;i++) printf("%d ", packet->data[i]);
      printf("\n");
    }
    */
   returnCode = dveSendDataPacket(dveSession, packet);

   dveFreeDataPacket(packet); 
   return(returnCode);
}




/* H263 display section */

static void initdecoder()
{
  int i, cc, size;
  FILE *cleared;

printf("Entering initdecoder()\n");
  
    MainWindow=XtWindow(MainForm);
  
printf("MainWindow:%d\n", (int)MainWindow);

  /* clip table */
  if (!(clp=(unsigned char *)malloc(1024)))
    error("malloc failed\n");

  clp += 384;

  for (i=-384; i<640; i++)
    clp[i] = (i<0) ? 0 : ((i>255) ? 255 : i);

  /* MPEG-1 = TMN parameters */
  matrix_coefficients = 5;


  switch (source_format) {
    case (SF_SQCIF):
      horizontal_size = 128;
      vertical_size = 96;
      break;
    case (SF_QCIF):
      horizontal_size = 176;
      vertical_size = 144;
      break;
    case (SF_CIF):
      horizontal_size = 352;
      vertical_size = 288;
      break;
    case (SF_4CIF):
      horizontal_size = 704;
      vertical_size = 576;
      break;
    case (SF_16CIF):
      horizontal_size = 1408;
      vertical_size = 1152;
      break;
    default:
      printf("ERROR: Illegal input format\n");
      exit(-1);
      break;
  }


  mb_width = horizontal_size/16;
  mb_height = vertical_size/16;
  coded_picture_width = horizontal_size;
  coded_picture_height = vertical_size;
  chrom_width =  coded_picture_width>>1;
  chrom_height = coded_picture_height>>1;
  blk_cnt = 6;

  for (cc=0; cc<3; cc++) {
    if (cc==0)
      size = coded_picture_width*coded_picture_height;
    else
      size = chrom_width*chrom_height;

    if (!(refframe[cc] = (unsigned char *)malloc(size)))
      error("malloc failed\n");

    if (!(oldrefframe[cc] = (unsigned char *)malloc(size)))
      error("malloc failed\n");

    if (!(bframe[cc] = (unsigned char *)malloc(size)))
      error("malloc failed\n");
  }

  for (cc=0; cc<3; cc++) {
    if (cc==0) {
      size = (coded_picture_width+64)*(coded_picture_height+64);
      if (!(edgeframeorig[cc] = (unsigned char *)malloc(size)))
        error("malloc failed\n");
      edgeframe[cc] = edgeframeorig[cc] + (coded_picture_width+64) * 32 + 32;
    }
    else {
      size = (chrom_width+32)*(chrom_height+32);
      if (!(edgeframeorig[cc] = (unsigned char *)malloc(size)))
        error("malloc failed\n");
      edgeframe[cc] = edgeframeorig[cc] + (chrom_width+32) * 16 + 16;
    }
  }

  if (expand) {
    for (cc=0; cc<3; cc++) {
      if (cc==0)
        size = coded_picture_width*coded_picture_height*4;
      else
        size = chrom_width*chrom_height*4;
      
      if (!(exnewframe[cc] = (unsigned char *)malloc(size)))
        error("malloc failed\n");
    }
  }

  /* Clear output file for concatenated storing */
  if (outtype == T_YUV_CONC) {
    if ((cleared = fopen(outputname,"wb")) == NULL) 
      error("couldn't clear outputfile\n");
    else
      fclose(cleared);
  }
  /* IDCT */
  if (refidct)
    init_idctref();
  else
    init_idct();

    init_display("", (int)MainWindow);
    printf("Display initialized\n");
}

void error(text)
char *text;
{
  fprintf(stderr,text);
  exit(1);
}

/* trace output */
void printbits(code,bits,len)
int code,bits,len;
{
  int i;
  for (i=0; i<len; i++)
    printf("%d",(code>>(bits-1-i))&1);
}


static int getval(argv)
char *argv[];
{
  int val;

  if (sscanf(argv[1]+2,"%d",&val)!=1)
    return 0;

  while (isdigit(argv[1][2]))
    argv[1]++;

  return val;
}


/* end of H263 display section */






