/*
 *	Protocol Specification for VideoPlugin
 *
 * Name:        JBVideoPlugin
 *
 * Description: handles h.263 video data
 *
 * Author:      Janusz Bulawa, NPAC
 * Date:	july, 1996
 */

#include <dve/dve.h>

#define VIDEO_PLUGIN_PORT   34999   /* plugin-to-plugin communication */
#define H263_DATA_PORT	    35000   /* RTP video data channel */
#define H263_CTL_PORT	    35001   /* RTCP asocciated with RTP data channel */

#define MAX_FRAME_SIZE	    5120
#define LOAD		    1024

#define STOP	0
#define	PLAY	1
#define	PAUSE	2

typedef struct _VPsession {
  DveSession dataSession;
  DveSession ctlSession;
  char *movietitle;
  char state;
  char frate;
} VPsession;

typedef enum {
  videoTagInvalid = 0,     /* Never used */
  videoTagPlay,    
  videoTagPause,    
  videoTagResume,
  videoTagFwSkip,
  videoTagBwSkip,
  videoTagStop,
  videoTagNewMovie,
  videoTagExit,
  videoTagConfirm,
  videoTagDenied,
  videoTagData
} VideoTag;

typedef struct videoPluginArg {
  char movie_title[128];	/* title of the movie to be played (with location) */
  int movie_id;
  char client_host[128];
  int clientUDPport;
} VideoPluginArg;

typedef struct videoDataArg {
  int len;
  char* videodata;
} VideoDataArg;
    
int lastMovieId=0;
int framenum=0;

int moviefd;
FILE *moviecapfd;
char* vdata;
int state;















